"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.help = exports.rcOptionsTypes = exports.cliOptionsTypes = exports.commandNames = void 0;
const lockfile_file_1 = require("@pnpm/lockfile-file");
const merge_lockfile_changes_1 = __importDefault(require("@pnpm/merge-lockfile-changes"));
const execa = require("execa");
const path = require("path");
const renderHelp = require("render-help");
exports.commandNames = ['lockfile-merge-driver'];
exports.cliOptionsTypes = () => ({});
exports.rcOptionsTypes = () => ({});
function help() {
    return renderHelp({
        usages: [],
    });
}
exports.help = help;
async function handler(opts, [ours, base, theirs, mergedFilePath]) {
    const mergedLockfile = merge_lockfile_changes_1.default((await lockfile_file_1.readWantedLockfile(ours, { ignoreIncompatible: true })), (await lockfile_file_1.readWantedLockfile(theirs, { ignoreIncompatible: true })));
    const cwd = path.dirname(mergedFilePath);
    await lockfile_file_1.writeWantedLockfile(cwd, mergedLockfile);
    let main = require.main.filename;
    if (path.basename(main) !== 'pnpm.js') {
        // This will happen only during testing
        main = path.join(__dirname, '../../pnpm/bin/pnpm.js');
    }
    execa.sync('node', [
        main,
        'install',
        '--lockfile-only',
        '--no-frozen-lockfile',
        '--force',
        '--ignore-scripts',
    ], { cwd });
}
exports.handler = handler;
//# sourceMappingURL=lockfileMergeDriver.js.map